<!doctype html>
<!--
    Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 3.4 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="./">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="../module4">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="../module4/synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="../module4/introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="../module4/exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module4/water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">v6.0-M1</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/v6.0-M1">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 3.4: Modeling larger systems</h1>
                    <p>
                        So far, in the course, you've seen examples of systems that contain multiple similar automata.
                        CIF features <em>automaton definitions</em>, a kind of parameterized templates that can be instantiated many times, making it easier to model multiple slightly different automata.
                        And you've also seen larger systems, with many automata.
                        For such systems, CIF features <em>groups</em> that add structure to model and allow you to keep a better overview.
                        And CIF also features <em>imports</em> that make it possible to split your model over multiple files, allowing you to reuse parts of your models in other models.
                    </p>

                    <h2>Automaton definitions</h2>
                    <p>
                        When modeling large systems, your models may have many similar components or parts modeled as similar automata.
                        For example, the <a href="../module2/more-detailed-models-water-lock-case.html">model of the water lock in Module 2</a>, included many sensors modeled as similar automata.
                        And when, for instance, a conveyer belt system handling luggage at an airport consists of 20 conveyor belts, it would be cumbersome and time-consuming to copy the same automaton repeatedly.
                        It can also hinder evolution of the model, as a change to one of the automata usually needs to be applied to the others as well.
                        Therefore, CIF has <em>automaton definitions</em> acting as some sort of template that can be used multiple times.
                        That is, automaton definitions are specified once and can be instantiated multiple times.
                        Each <em>automaton instantiation</em> is then a concrete automaton, a copy of its definition.
                    </p>
                    <p>
                        As an example, consider again the hay baler and bale loader from the <a href="../module2/exercises.html#exercise7a">solution to Exercise 7a</a> of Module 2.
                        The <code>baler1</code> and <code>baler2</code> automata are exactly the same, except for the names of the automata.
                        We can make an automaton definition that represents the behavior of a baler, and instantiate it twice, one for each baler:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton def Baler():
                                event make_bale;
                                disc int bales = 0;

                                location:
                                    initial;
                                    marked;
                                    edge make_bale do bales := bales + 1;
                            end

                            baler1: Baler();
                            baler2: Baler();
                        </code>
                    </pre>
                    <p>
                        The <code>Baler</code> automaton definition is nearly identical to the original <code>baler1</code> and <code>baler2</code> automata.
                        The automaton definition is identified by the <code>def</code> keyword between the <code>automaton</code> keyword and the name of the automaton definition, as well as by the parentheses after its name.
                    </p>
                    <p>
                        An automaton definition by itself is not an automaton.
                        The instantiations of the automaton definition, <code>baler1</code> and <code>baler2</code> in this case, however, are automata.
                        Before the colon, the name of the instantiation is given, which indicates the name of the automaton that is produced by instantiating the automaton definition.
                        After the colon, the name of the automaton definition that is to be instantiated is given.
                        The above automaton definition and two instantiations <code>baler1</code> and <code>baler2</code>, have the exact same behavior as the two original <code>baler1</code> and <code>baler2</code> automata.
                    </p>
                    <p>
                        Using automaton definitions and multiple instantiations, much of the duplication in a model can be avoided.
                        This saves time and thereby improves modeling efficiency, as the duplicate parts don't each have to be written separately or be copied and adapted.
                        Furthermore, it is easier to extend the model.
                        If, for example, the neighboring farm decides to lend you their baler, the model can be easily extended by adding an extra automaton instantiation, which requires only one new line: <code>baler3: Baler();</code>.
                        And making adaptations in a consistent way is also made easier, as when an automaton definition is adapted, all its instantiations are automatically and consistently adapted as well.
                        For example, when changing the name of the <code>bales</code> variable to <code>bales_made</code>, the variable name only needs to be changed in the automaton definition.
                        The automaton instantiations automatically adopt this change.
                        Automaton definitions and instantiations thus allow for scalability and reuse and improve maintainability.
                    </p>
                    <p>
                        Similar to how an automaton can be labeled a <code>plant</code>, so too can automaton definitions.
                        If a plant automaton definition is defined, and it is instantiated, then each instantiation is a plant automaton.
                        That is, instead of <code>automaton def Baler():</code> you could also write <code>plant def Baler():</code>.
                    </p>
                    <p>
                        In CIF, as a convention, names of automaton definitions usually start with an uppercase letter, while instantiations are usually given a name that start with a lowercase letter, just like automata.
                        For instance, an automaton definition could be named <code>LockDoor</code> and the instantiations could be named <code>left_door</code> and <code>right_door</code>.
                    </p>

                    <h2>Parameterized automaton definitions</h2>
                    <p>
                        In practice, models often have similar, but not exactly identical automata.
                        They are largely the same, but they differ in a few details.
                        For instance, they could have the same variables, but with different values.
                        Or they could have the same edges, but for different events.
                        To support this, automaton definitions can be given <em>parameters</em>.
                        And the instantiations can then give different <em>arguments</em> for these parameters.
                    </p>

                    <h3>Algebraic parameters</h3>
                    <p>
                        For instance, for the hay baler an bale loader example of Module 2, you also made a version of the bale loader that has a capacity of <code>10</code> bales, as part of <a href="../module2/exercises.html#exercise7b">Exercise 7b</a>.
                        Now consider that the farmer were to call a neighbor, who owns a bale loader with a capacity of <code>20</code> bales, to come help him.
                        Both bale loader automata would be identical, except for the value of the <code>load_capacity</code> constant.
                        With the parameterized automaton definition, it is still possible to make a template once and use it twice:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton def BaleLoader(alg int load_capacity):
                                event load_bales;
                                disc int loaded_bales = 0;

                                alg bool enough_bales = bales_on_field >= load_capacity;

                                location:
                                    initial;
                                    marked;
                                    edge load_bales  when enough_bales do loaded_bales := loaded_bales + load_capacity;
                                    edge stop_baling when enough_bales;
                            end

                            baler_loader_small: BaleLoader(10);
                            baler_loader_large: BaleLoader(20);
                        </code>
                    </pre>
                    <p>
                        The <code>load_capacity</code> constant has been replaced by a parameter.
                        This parameter has the same name and type as the constant, but since it is a parameter it can be given different values for each instantiation.
                        Automaton instantiation <code>bale_loader_small</code> provides value <code>10</code> and therefore represents the bale loader of the farmer.
                        Automaton instantiation <code>bale_loader_large</code> provides value <code>20</code> and thus represents the neighbor's bale loader.
                    </p>
                    <p>
                        In this case, since a value is to be passed to the automaton definition, an <em>algebraic parameter</em> is used, as indicated by the <code>alg</code> keyword.
                        An algebraic parameter is very similar to an algebraic variable, except that the parameter is not given a defining expression.
                        Instead, the instantiation provides the expression.
                        In the example above, fixed values are given, but these could also be computations, similar to how the defining expressions of algebraic variables can also be computations.
                        When an automaton definition with an algebraic parameter is instantiated, a copy of the automaton definition is made, which is a concrete automaton.
                        Within that copy, an algebraic variable is put with the same name and type as the algebraic parameter, and with the expression given in the instantiation as its defining expression.
                        The parameter is then removed from the copy.
                    </p>
                    <p>
                        If there were a third bale loader helping out the farmer, and it has a capacity of 5 bales, the model could easily be extended by adding one line: <code>bale_loader_tiny: BaleLoader(5)</code>.
                    </p>

                    <h3>Location parameters</h3>
                    <p>
                        Besides algebraic parameters, CIF also supports <em>location parameters</em>.
                        These are similar to algebraic parameters, but only allow locations to be passed via instantiations.
                        For instance, consider the following example:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            plant def Button():
                                uncontrollable u_pushed, u_released;

                                location Released:
                                    initial;
                                    marked;
                                    edge u_pushed goto Pushed;

                                location Pushed:
                                    edge u_released goto Released;
                            end

                            button1: Button();
                            button2: Button();

                            plant def Motor(location allow_on, allow_off):
                                controllable c_turn_on, c_turn_off;

                                location Off:
                                    initial;
                                    marked;
                                    edge c_turn_on  when allow_on  goto On;
                                location On:
                                    edge c_turn_off when allow_off goto Off;
                            end

                            motor1: Motor(button1.Pushed, button1.Released);
                            motor2: Motor(button2.Pushed, button2.Released);
                        </code>
                    </pre>
                    <p>
                        The <code>Button</code> automaton definition models a simple button that can be pushed and released.
                        It is instantiated twice, leading to two buttons: <code>button1</code> and <code>button2</code>.
                        The <code>Motor</code> automaton definition models a simple motor, that can be turned on and off.
                        It is parameterized with two location parameters: <code>allow_on</code> indicates when it is allowed to turn on the motor, and <code>allow_off</code> indicates when it is allowed to turn off the motor.
                        The location parameters are used to guard the edges for the <code>c_turn_on</code> and <code>c_turn_off</code> event, respectively.
                        They only allow the motor to be turned on if the <code>allow_on</code> location is the current location of the automaton that contains it, and similarly for turning the motor off.
                        There are two automaton instantiations for the motor: <code>motor1</code> and <code>motor2</code>.
                        For <code>motor1</code>, location <code>Pushed</code> of automaton instantiation <code>button1</code> is pass as argument for parameter <code>allow_on</code>.
                        This means that <code>motor1</code> can only be turned on if <code>button1</code> is pushed.
                        And something similar is done for <code>motor2</code> and <code>button2</code>, as well as for the motors to be allowed to be turned off.
                    </p>
                    <p>
                        In this example, the <code>location allow_on</code> parameter could easily be changed to <code>alg bool allow_on</code>.
                        The model would then have the same behavior.
                    </p>

                    <h3>Event parameters</h3>
                    <p>
                        CIF also features <em>event parameters</em> that allow passing different events to automaton definitions, which can then be used on edges.
                        Consider for instance the following example:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton def ConveyorBelt(event accept, provide):
                                location NoProduct:
                                    initial;
                                    marked;
                                    edge accept goto HasProduct;

                                location HasProduct:
                                    edge provide goto NoProduct;
                            end

                            event start, move1to2, move2to3, move3to4, exit;

                            belt1: ConveyorBelt(start, move1to2);
                            belt2: ConveyorBelt(move1to2, move2to3);
                            belt3: ConveyorBelt(move2to3, move3to4);
                            belt4: ConveyorBelt(move3to4, exit);
                        </code>
                    </pre>
                    <p>
                        The <code>ConveyorBelt</code> models a conveyer belt.
                        Initially, it has no product, but it can accept a product and move it over its belt.
                        Then once the product is at the end, it can provide the product to the next belt in production line.
                        It is parameterized with two events: <code>accept</code> to accept a product onto the belt, and <code>provide</code> to provide its product to the next belt.
                        Five events are defined in the model.
                        Event <code>start</code> is used to start the system and move a product to the first belt.
                        Event <code>move1to2</code> moves a product from the first belt to the second belt.
                        Events <code>move2to3</code> and <code>move3to4</code> are similar.
                        Event <code>exit</code> is used to accept the product from the last belt, allowing it to exit the system.
                        Four automaton instantiations of the <code>ConveyorBelt</code> automaton definition are defined.
                        They pass the relevant events as arguments, such that the products are properly transferred from one belt to another.
                        For instance, <code>belt2</code> passes event <code>move2to3</code> for the <code>provide</code> parameter, as it provides the product from <code>belt2</code> to <code>belt3</code>.
                        And <code>belt3</code> passes that same event for the <code>accept</code> parameter, as it accepts the product from <code>belt2</code>.
                        This way, both <code>belt2</code> and <code>belt3</code> have an edge for event <code>move2to3</code>.
                        They synchronize on that event, and thus together perform a transition for that event.
                        This way, a product is provided by <code>belt2</code> and accepted by <code>belt3</code> in a single transition, leading to a handover of the product from the second to the third belt.
                    </p>

                    <h3>Multiple parameters</h3>
                    <p>
                        In the conveyer belt example, two event parameters were defined using <code>event accept, provide</code>.
                        Multiple algebraic or location parameters can be defined similarly, such as: <code>alg int x, y</code> and <code>location loc1, loc2</code>.
                        If different kinds of parameters are desired on a single automaton definition, they are separated by semicolons, like so: <code>alg int x, y; event e, f</code>.
                        Similarly, if different types of algebraic parameters are to be defined, they too are separated by semicolons: <code>alg int a, b; alg bool c, d</code>.
                        The two event parameters of the conveyor belt example could also have been written as <code>event accept; event provide</code>, but <code>event accept, provide</code> is shorter and therefore preferred.
                    </p>

                    <h2>Groups</h2>
                    <p>
                        When modeling a large system, it can be useful to add more structure to it.
                        CIF features <em>groups</em>, named collections of automata and other declarations.
                    </p>
                    <p>
                        For example, consider a road intersection at two crossing two-directional roads.
                        Each of the four directions (north, east, south and west) has traffic lights for going left, straight ahead and right.
                        So, there are twelve traffic lights.
                        This system could be modeled in CIF as follows:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton def LeftTrafficLight():
                                ...
                            end

                            automaton def StraightTrafficLight():
                                ...
                            end

                            automaton def RightTrafficLight():
                                ...
                            end

                            group north:
                                left:     LeftTrafficLight();
                                straight: StraightTrafficLight();
                                right:    RightTrafficLight();
                            end

                            group east:
                                left:     LeftTrafficLight();
                                straight: StraightTrafficLight();
                                right:    RightTrafficLight();
                            end

                            group south:
                                left:     LeftTrafficLight();
                                straight: StraightTrafficLight();
                                right:    RightTrafficLight();
                            end

                            group west:
                                left:     LeftTrafficLight();
                                straight: StraightTrafficLight();
                                right:    RightTrafficLight();
                            end
                        </code>
                    </pre>
                    <p>
                        The use of automaton definitions and instantiations prevents having to copy the various traffic light automata many times.
                        The bodies the automaton definitions are left out here, as they are not relevant for showing the concept of groups.
                        The use of groups makes this CIF model structured and easy to read.
                    </p>
                    <p>
                        Groups may not only contain automaton instantiations, but also automata, events, constants, algebraic variables, or any combination of them that you think conceptually belong together.
                        In fact, groups may contain whatever is allowed to be specified in models outside automata.
                        In a way, the model as whole could be seen as an implicit group.
                    </p>
                    <p>
                        To refer to something that is declared inside a group, prefix the name of the declaration with the name of the group and a period.
                        For instance, we could refer to the southern left traffic light by <code>south.left</code>.
                        And if left traffic lights have an <code>On</code> location, then we could refer to the one for the south left traffic light by <code>south.left.On</code>.
                    </p>

                    <h2>Group definitions</h2>
                    <p>
                        The traffic light model above is already somewhat structured, but it can still be improved.
                        The four groups are identical and only differ in name.
                        To change something in the groups, it has to be changed separately in all groups, which is burdensome.
                        And when changing one of them, it is easy to forget to update the other groups.
                    </p>
                    <p>
                        Similar to how automaton definitions can be used to reuse automata, group definitions can be used to reuse groups.
                        Group definitions are thus templates for groups that can be instantiated multiple times.
                        Group definitions can have the same kind of parameters as automaton definitions, and they are also instantiated in the same way.
                        Similar to how automaton definitions are not automata, group definitions are not groups, but instantiated group definitions are.
                        The following model shows how the traffic lights model can be simplified further using a group definition:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton def LeftTrafficLight():
                                ...
                            end

                            automaton def StraightTrafficLight():
                                ...
                            end

                            automaton def RightTrafficLight():
                                ...
                            end

                            group def TrafficLights():
                                left:     LeftTrafficLight();
                                straight: StraightTrafficLight();
                                right:    RightTrafficLight();
                            end

                            north: TrafficLights();
                            east:  TrafficLights();
                            south: TrafficLights();
                            west:  TrafficLights();
                        </code>
                    </pre>
                    <p>
                        All duplication is removed from the model.
                        The model has more structure, is simpler and easier to read.
                    </p>

                    <h2>Components</h2>
                    <p>
                        In CIF, automata and groups are together called <em>components</em>.
                        The entire model is the largest component.
                        It can be subdivided into groups, which are sub-components.
                        Groups can be nested, to create sub-sub-components, and so on.
                        The model and any (sub-)groups in it, may contain automata.
                        An automaton in the model is a sub-component, an automaton in a group in the model is a sub-sub-component, and so on.
                        As automata and groups are together called components, and both allow definitions and instantiations, this concept is often referred to as the <em>component definition/instantiation</em> concept.
                    </p>

                    <h2>Component parameters</h2>
                    <p>
                        Besides algebraic, location and event parameters, CIF also features component parameters.
                        This allows an entire component to be provided as a parameter to a component definition.
                        For instance, consider again the button/motor example above.
                        The motor is given the two locations of the button separately.
                        If we use a component parameter, only one parameter is needed:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            plant def Button():
                                uncontrollable u_pushed, u_released;

                                location Released:
                                    initial;
                                    marked;
                                    edge u_pushed goto Pushed;

                                location Pushed:
                                    edge u_released goto Released;
                            end

                            button1: Button();
                            button2: Button();

                            plant def Motor(Button button):
                                controllable c_turn_on, c_turn_off;

                                location Off:
                                    initial;
                                    marked;
                                    edge c_turn_on  when button.Pushed   goto On;
                                location On:
                                    edge c_turn_off when button.Released goto Off;
                            end

                            motor1: Motor(button1);
                            motor2: Motor(button2);
                        </code>
                    </pre>
                    <p>
                        Automaton definition <code>Motor</code> has a component parameter named <code>button</code> that expects an instance of the <code>Button</code> component definition to be passed to it.
                        For <code>motor1</code> the instantiated component <code>button1</code> is provided, while for <code>motor2</code> the argument is <code>button2</code>.
                        Within the <code>Motor</code> definition, the elements of the <code>Button</code> definition can be accessed, such as its locations.
                        You can see examples in the guards of the edges, such as <code>button.Pushed</code>, which refers to the <code>Pushed</code> location of the <code>button</code>.
                    </p>

                    <h2>Imports</h2>
                    <p>
                        So far, we have prevented duplication within a model, by using constants and algebraic variables for values that are used multiple times, and by using component definitions and instantiations for similar components.
                        But, what about duplication between different models?
                        CIF supports imports, that allow you to divide a model over multiple files.
                        You can import one model in the other, to make sure they are together one model again.
                    </p>
                    <p>
                        Consider for instance two road intersections.
                        One we saw earlier, and it has north, east, south and west directions.
                        The other has only three directions: north, east and south.
                        The definitions of the left, straight ahead and right traffic lights are the same.
                        They can thus be shared between the models for the different intersections.
                        That is, we could model the two intersections, using the following three CIF models:
                    </p>
                    <p>
                        File <code>definitions.cif</code> contains the common definitions:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton def LeftTrafficLight():
                                ...
                            end

                            automaton def StraightTrafficLight():
                                ...
                            end

                            automaton def RightTrafficLight():
                                ...
                            end
                        </code>
                    </pre>
                    <p>
                        File <code>intersection4.cif</code> models the intersection with 4 directions:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            import "definitions.cif";

                            group def TrafficLights():
                                left:     LeftTrafficLight();
                                straight: StraightTrafficLight();
                                right:    RightTrafficLight();
                            end

                            north: TrafficLights();
                            east:  TrafficLights();
                            south: TrafficLights();
                            west:  TrafficLights();
                        </code>
                    </pre>
                    <p>
                        File <code>intersection3.cif</code> models the intersection with 3 directions:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            import "definitions.cif";

                            group north:
                                left:     LeftTrafficLight();
                                straight: StraightTrafficLight();
                            end

                            group east:
                                left:     LeftTrafficLight();
                                right:    RightTrafficLight();
                            end

                            group south:
                                straight: StraightTrafficLight();
                                right:    RightTrafficLight();
                            end
                        </code>
                    </pre>
                    <p>
                        The <code>definitions.cif</code> file contains the common definitions.
                        These are imported into the other models using an import declaration.
                        An import can be thought of as being replaced by the content of the imported file.
                    </p>
                    <p>
                        The <code>import</code> keyword is followed by the file name or path to the file to import.
                        The file name or path is enclosed in double quotes (<code>"</code>) and followed by a semicolon (<code>;</code>).
                        To import a CIF file from another directory, an import like <code>import "directory/file.cif";</code> can be used.
                        It is recommended to use <code>/</code> as separator, to make sure models work on all platforms (Windows, Linux, macOS).
                    </p>
                    <p>
                        Another common use of imports, is for structuring large models.
                        Each sub-system can then be put in a different model.
                        And the sub-systems are then all imported into the main system model.
                    </p>

                    <h2 id="quiz">Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'single-choice',
                                question: `
                                    What is the difference, syntax-wise, between automata and automaton definitions?
                                    Is this the same as for groups and group definitions?
                                `,
                                answers: [
                                    `Automaton definitions use the <code>def</code> keyword and between parentheses they can optionally have parameters.
                                     Automata do not have either of those.
                                     The same is true for groups and group definitions.`,
                                    `Automata use the <code>def</code> keyword and between parentheses they can optionally have parameters.
                                     Automaton definitions do not have either of those.
                                     The same is true for groups and group definitions.`,
                                    `Automaton definitions use the <code>def</code> keyword and between parentheses they can optionally have parameters.
                                     Automata do not have either of those.
                                     For groups and group definitions it is the other way around.`,
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'multiple-choice',
                                question: "Which two kind of parameters can a definition take?",
                                answers: [
                                    "Algebraic parameters.",
                                    "Component parameters.",
                                    "Constant parameters.",
                                    "Discrete parameters.",
                                    "Event parameters.",
                                    "Guard parameters.",
                                    "Location parameters.",
                                ],
                                correctAnswer: '1, 2, 5, 7'
                            },
                            {
                                type: 'single-choice',
                                question: "Why and when are groups useful?",
                                answers: [
                                    `When the system being modeled contains parts that the modeler thinks conceptually belong together.
                                     It improves the structure of the model and makes it easier to read and understand.`,
                                    "When the system being modeled is very big, groups are needed to keep the model functional and efficient.",
                                    `When the system being modeled belongs to a group of systems previously modeled, you add this model to the group.
                                     This structures the group of models.`,
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    A clothing company does business in three different countries.
                                    It has two factories in each country.
                                    Each factory consists of two halls, and each hall houses four machines.
                                    How can this best be modeled in CIF?`,
                                answers: [
                                    `Automaton definitions for a hall and a machine.
                                     A group definition for a factory containing two hall automaton instantiations and two machine automaton instantiations.
                                     A group definition for a country containing two factory group instantiations.
                                     Three country group instantiations in the model.`,
                                    `An automaton definition for a machine.
                                     A group definition for a hall containing four machine automaton instantiations.
                                     A group definition for a factory containing two hall group instantiations.
                                     A group definition of a country containing two factory group instantiations.
                                     Three country group instantiations in the model.`,
                                    `An automaton definition for a machine.
                                     A group definition for a hall containing two machine automaton instantiations.
                                     A group definition for a factory containing three hall group instantiations.
                                     A group definition for a country containing four factory group instantiations.
                                     Two country group instantiations in the model.`,
                                ],
                                correctAnswer: '2'
                            },
                            {
                                type: 'multiple-choice',
                                question: "What is a good use of the import concept, and how do you import a file?",
                                answers: [
                                    `When you want to import a file from somebody else, you use the import functionality to import it into your workspace.
                                     You import a file by typing the <code>import</code> keyword and the path to the file you want to import between double quotes.`,
                                    `When a model becomes very large and covers multiple parts of a system, you can divide it into separate files to structure it.
                                     You import a file by typing the <code>import</code> keyword and the path to the file you want to import between double quotes.`,
                                    `When your model becomes too large, you have to divide the model into multiple files to ensure the tools keep running efficiently.
                                     You import a file by typing the <code>import</code> keyword and the path to the file you want to import between double quotes.`,
                                    `When you want to reuse a part of your model in another model, you can separate out the common part to another file, and import it into both models.
                                     You import a file by typing the <code>import</code> keyword and the path to the file you want to import between double quotes.`
                                ],
                                correctAnswer: '2, 4'
                            }
                        ]
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="supervisory-controller-synthesis.html">Go back to Module 3.3</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="exercises.html">Proceed to Module 3.5</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2024 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
